
/*
Version 01.12.2023
*ERMER Christof**
*/
/* HYSTORY
*/

//#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/pgmspace.h>
#include "TextService.h"
#include "Befehle.h"
#include "uart328.h"
#include "main.h"

char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
char * gpcRxPars;
COMMAND_TYPE gsCmd;  // MIT OrderFlag
	//  gsCmd.CREventFlag

//PROTO
void TokensRXStr(char *pcStrOrder); //von gcaRxStr

/*
// **********
void TxCR(void)
// **********
{
uart_putc(13);
};
*/

/*
// **********
void TxLF(void)
// **********
{
	uart_putc(10);
};
*/
//**********
void TxCRLF(void)
//**********
{
uart_putc(13);
uart_putc(10);
};

// *********************************
void CheckOrder(void) //von gcaRxStr
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL[,WERT]" BSP: "SFR,1000"
//========================
TokensRXStr( gcaRxStr );
//========================
ResetRxBuff();
//========================

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("REL1") )  )
{
	(gsCmd.i16CmdVal_1) ? (REL1_ON())  : (REL1_OFF());
	return;
}

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("REL2") )  )
{
	(gsCmd.i16CmdVal_1) ? (REL2_ON())  : (REL2_OFF());
	return;
}

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("REL3") )  )
{
	(gsCmd.i16CmdVal_1) ? (REL3_ON())  : (REL3_OFF());
	return;
}

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPORTB") )  )
{
	DDRB |= gsCmd.i16CmdVal_1;
	PORTB |= gsCmd.i16CmdVal_1;
	return;
};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("CLRPORTB") )  )
{
	DDRB |= gsCmd.i16CmdVal_1;
	PORTB &= ~gsCmd.i16CmdVal_1;
	return;
};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPORTD") )  )
{
	DDRD |= gsCmd.i16CmdVal_1;
	PORTD |= gsCmd.i16CmdVal_1;
	return;
};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("CLRPORTD") )  )
{
	DDRD |= gsCmd.i16CmdVal_1;
	PORTD &= ~gsCmd.i16CmdVal_1;
	return;
};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TRAFFIC") )  )
{
	gstFlags.Traffic_Flag = gsCmd.i16CmdVal_1;
	uart_puts_p( PSTR("Traffic:") );
	uart_puts( ULongToNumStr(gsCmd.i16CmdVal_1) );
	TxCRLF();
	return;
};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	uart_puts_p( PSTR("PONG\r\n") );
	return;
	}

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("??") )  )
{	
	uart_puts_p( PSTR("REL{1,2,3}\r\n") );
	uart_puts_p( PSTR("SETPORTD(B)\r\n") );
	uart_puts_p( PSTR("CLRPORTD(B)\r\n") );
/*
	uart_puts_p( PSTR("TRAFFIC,\r\n") );	
	uart_puts_p( PSTR("Device\r\n") );
	uart_puts_p( PSTR("PING\r\n") );	
	uart_puts_p( PSTR("??\r\n") );
*/	return;
}

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT") )  )
	{	
	uart_puts( ULongToNumStr(gu32Ticks) );	
	TxCRLF();
	return;
	}

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))
	{
	uart_puts_p( PSTR("3xRelais\r\n") );
	return;
	};

TxCRLF();  //uart_putc(13);
}; // ORDER

// **************************
void ResetRxBuff(void)
// **************************
{
uart_flush();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
gsCmd.UartCREventFlag = 0;
};


//Funktionen Definition
// *******************************************************************
void UART_RX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
if( gsCmd.UartCREventFlag == 1)  // if 1 Tu nix.
	{
	return;
	}; // Verriegele, wenn Job aktiv
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
//NOW SELECT ACTION FROM ORDER
  if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
    {
    if( (uiRxUart & 0xFF) == 13)
      {
      gsCmd.UartCREventFlag = 1;
      return;
      };	           				        

    if( (uiRxUart & 0xFF) < 33 )
      {
      return;
      }
    else
      {
      // Accumulate String only to gcaRxStr with  Parser
      *gpcRxPars++ = (unsigned  char)(uiRxUart & 0x00FF);//Append rxByte
      *gpcRxPars = 0; //ZERO carry
      return;
      };
    }
  else  // To much data Rx, than clear simple all
    {//overflow of RX clears all
    ResetRxBuff();
    };
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};


/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
const char caDelimiter[]= ",";
char * pStrTok; // f�r strtok_r
//char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*
//char * 	strtok_r (char *, const char *, char **)
//char * 	strtok (char *, const char *)
//if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
if( (pStrTok = strtok( pcStrOrder, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10
//f�r 2 fVal Variablen nach dem Kommand
gsCmd.i16CmdVal_1 = 0;
//gsCmd.i16CmdVal_2 = 0;
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atol(pStrTok);
	};
//HIER NULL POINTER
/*
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
	//gsCmd.f16CmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};	
*/
};
